-- by AntonioModer (https://twitter.com/AntonioModer)
if arg[#arg] == "-debug" then require("mobdebug").start() end																							-- ZeroBraneStudio debuger

function love.load(arg)
--	love._openConsole()
	love.window.setMode(1600, 900)
	
	font12 = love.graphics.newFont(12)
	font32 = love.graphics.newFont(32)
	
	image = {}
	image.background = love.graphics.newImage([[background.png]])
--	image.backgroundWhite = love.graphics.newImage([[backgroundWhite.png]])	
--	image.light1 = love.graphics.newImage([[light1.png]])
	image.test = love.graphics.newImage([[test.png]])
	
	currentBM = {}
	currentBM[1] = 'alpha'
	currentBM[2] = 'add'
	currentBM[3] = 'screen'	
	currentBM[4] = 'multiply'	
	currentBM[5] = 'subtract'
	currentBM[6] = 'replace'
	currentBM.i = 1
end

function love.keypressed( key, scancode, isrepeat )
	if key == 'escape' then
--		love.system.vibrate(3)
--		love.event.wait(3)
		
		love.event.quit()
--		love.event.push('quit')
	end
end

function love.update()
	lBGlobalRGB = 1.16								-- яркость света (light brightness); 0.0 ... 1.0
	lBGlobalA = 1.41
	if lBGlobalRGB > 1.0 then lBGlobalRGB = 1.00 elseif lBGlobalRGB < 0 then lBGlobalRGB = 0 end
	if lBGlobalA > 1.0 then lBGlobalA = 1.00 elseif lBGlobalA < 0 then lBGlobalA = 0 end	
end

function love.draw()
	love.graphics.setBackgroundColor(255, 0, 255, 255)
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(image.background, 0, 0, 0, love.graphics.getWidth()/image.background:getWidth(), love.graphics.getHeight()/image.background:getHeight())
	---------------------------------------------
	
	-- test BlendMode
	for y=1, 2 do
		for x=1, 3 do
			if x == 3 and y == 2 then currentBM.i = 1; break end
			
			love.graphics.setColor(255*lBGlobalRGB, 255*lBGlobalRGB, 255*lBGlobalRGB, 255*lBGlobalA)
			love.graphics.setBlendMode(currentBM[currentBM.i])
			local imageSize = image.test:getWidth()
			love.graphics.draw(image.test, imageSize*(x-1), imageSize*(y-1)+32*y)	
			love.graphics.setBlendMode('alpha')
			love.graphics.setColor(0, 0, 0, 255)
			love.graphics.setFont(font32)
			love.graphics.print(currentBM[currentBM.i], imageSize*(x-1)+imageSize/3, imageSize*(y-1)+32*y+imageSize)
			love.graphics.setFont(font12)
			currentBM.i = currentBM.i+1
		end
	end
	---------------------------------------
	
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.rectangle('fill', 5, 5, 600, 15*2)	
	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.print('FPS: '..love.timer.getFPS(), 7, 5)
	love.graphics.print([[blend modes test LOVE 0.10.0; by AntonioModer (https://twitter.com/AntonioModer)]], 7, 20)
end